Summary: A flexible, stable and highly-configurable FTP Server.
Name: proftpd
Version: 1.3.0
Release: 1.norlug%{?_with_ldap:_ldap}%{?_with_mysql:_mysql}%{?_with_postgres:_postgres}
Group: System Environment/Daemons
License: GPL
URL: http://www.proftpd.org/
Source: ftp://proftpd.org/distrib/source/%{name}-%{version}.tar.bz2
Source1: proftpd.conf
Source2: proftpd.init
Source3: proftpd-xinetd
Source4: proftpd.logrotate
Source5: welcome.msg
Buildroot: %{_tmppath}/%{name}-root
Requires: pam >= 0.59, /sbin/service, /sbin/chkconfig, /etc/init.d
%{?_with_ldap:Requires: openldap}
%{?_with_ldap:BuildRequires: openldap-devel}
%{?_with_mysql:Requires: mysql}
%{?_with_mysql:BuildRequires: mysql-devel}
%{?_with_postgres:Requires: postgresql}
%{?_with_postgres:BuildRequires: postgresql-devel}
%{?_with_tls:Requires: openssl}
%{?_with_tls:BuildRequires: openssl-devel}
BuildRequires: pam-devel, perl
Provides: ftpserver
Conflicts: wu-ftpd, anonftp, vsftpd

%description
ProFTPD is an enhanced FTP server with a focus toward simplicity, security,
and ease of configuration. It features a very Apache-like configuration
syntax, and a highly customizable server infrastructure, including support for
multiple 'virtual' FTP servers, anonymous FTP, and permission-based directory
visibility.

This package defaults to the standalone behaviour of ProFTPD, but all the
needed scripts to have it run by xinetd instead are included.

Available rpmbuild rebuild options :
--with : ldap mysql postgres tls

%prep
%setup -q

%build
# Workaround for the PostgreSQL include file
perl -pi -e 's|pgsql/libpq-fe.h|libpq-fe.h|g' contrib/mod_sql_postgres.c

%configure \
	--with-includes=%{_includedir} \
	%{?_with_mysql:--with-libraries=%{_libdir}/mysql} \
	%{?_with_postgres:--with-libraries=%{_libdir}} \
	--with-modules=mod_readme:mod_auth_pam%{?_with_ldap::mod_ldap}%{?_with_mysql::mod_sql:mod_sql_mysql}%{?_with_postgres::mod_sql:mod_sql_postgres}%{?_with_tls::mod_tls}
make %{?_smp_mflags}

%install
rm -rf %{buildroot}
%makeinstall rundir=%{buildroot}%{_localstatedir}/run/proftpd \
	INSTALL_USER=`id -un` \
	INSTALL_GROUP=`id -gn`
install -D -m 644 contrib/dist/rpm/ftp.pamd %{buildroot}%{_sysconfdir}/pam.d/ftp
install -D -m 640 %{SOURCE1} %{buildroot}%{_sysconfdir}/proftpd.conf
install -D -m 755 %{SOURCE2} %{buildroot}%{_sysconfdir}/rc.d/init.d/proftpd
install -D -m 640 %{SOURCE3} %{buildroot}%{_sysconfdir}/xinetd.d/proftpd
install -D -m 644 %{SOURCE4} %{buildroot}%{_sysconfdir}/logrotate.d/proftpd
install -D -m 644 %{SOURCE5} %{buildroot}/var/ftp/welcome.msg
mkdir -p %{buildroot}/var/ftp/uploads
mkdir -p %{buildroot}/var/ftp/pub
mkdir -p %{buildroot}/var/log/proftpd
touch %{buildroot}%{_sysconfdir}/ftpusers

%post
if [ $1 = 1 ]; then
	/sbin/chkconfig --add proftpd
	IFS=":"; cat /etc/passwd | \
	while { read username nu nu gid nu nu nu nu; }; do \
		if [ $gid -lt 100 -a "$username" != "ftp" ]; then
			echo $username >> %{_sysconfdir}/ftpusers
		fi
	done
fi

%preun
if [ $1 = 0 ]; then
	/sbin/service proftpd stop >/dev/null 2>&1 || :
	/sbin/chkconfig --del proftpd
	/sbin/service xinetd reload >/dev/null 2>&1 || :
	if [ -d /var/run/proftpd ]; then
		rm -rf /var/run/proftpd/*
	fi
fi

%postun
if [ $1 -ge 1 ]; then
	/sbin/service proftpd condrestart >/dev/null 2>&1
fi

%clean
rm -rf %{buildroot}

%files
%defattr(-, root, root)
%doc COPYING CREDITS ChangeLog NEWS README README.LDAP README.mod_sql
%doc README.modules README.PAM doc/* sample-configurations
%dir %{_localstatedir}/run/proftpd
%config(noreplace) %{_sysconfdir}/proftpd.conf
%config(noreplace) %{_sysconfdir}/xinetd.d/proftpd
%config %{_sysconfdir}/ftpusers
%config %{_sysconfdir}/pam.d/ftp
%config %{_sysconfdir}/logrotate.d/proftpd
%{_sysconfdir}/rc.d/init.d/proftpd
%{_mandir}/*/*
%{_bindir}/*
%{_sbindir}/*
%dir /var/ftp
%attr(331, ftp, ftp) %dir /var/ftp/uploads
%dir /var/ftp/pub
%config(noreplace) /var/ftp/welcome.msg
%attr(750, root, root) %dir /var/log/proftpd

%changelog
* Thu Apr 20 2006 Chip Cuccio <chipster@norlug.org> 1.3.0-1
- updated (holy shit)

* Wed Sep 15 2004 Chip Cuccio <chipster@norlug.org> 1.2.10-1
- updated (finally)

* Wed Nov 5 2003 Chip Cuccio <chipster@norlug.org> 1.2.9-1
- update to 1.2.9

* Wed Sep 24 2003 Chip Cuccio <chipster@norlug.org>
- initial rh-7.3 build
- built in response to X-Force Vuln;
  <http://xforce.iss.net/xforce/alerts/id/154>

